## org.apache.lucene.index
Class MultiReader

    java.lang.Object
      org.apache.lucene.index.IndexReader
          org.apache.lucene.index.MultiReader

All Implemented Interfaces:
  Closeable, Cloneable

Direct Known Subclasses:
  SlowMultiReaderWrapper

    public class MultiReader

extends IndexReader
implements Cloneable

An IndexReader which reads multiple indexes, appending their content.

Nested Class Summary

Nested classes/interfaces inherited from class org.apache.lucene.index.IndexReader
`IndexReader.ReaderClosedListener`

Field Summary
`protected int[]` `starts`
`protected IndexReader[]` `subReaders`

Fields inherited from class org.apache.lucene.index.IndexReader
`hasChanges`

Constructor Summary
`MultiReader(IndexReader... subReaders)` Construct a MultiReader aggregating the named set of (sub)readers.
`MultiReader(IndexReader[] subReaders, boolean closeSubReaders)` Construct a MultiReader aggregating the named set of (sub)readers.

Method Summary
`Object` `clone()` Efficiently clones the IndexReader (sharing most internal state).
`IndexReader` `clone(boolean openReadOnly)` Deprecated. Write support will be removed in Lucene 4.0. Use `clone()` instead.
`int` `docFreq(Term t)` Returns the number of documents containing the term `t`.
`protected void` `doClose()` Implements close.
`protected void` `doCommit(Map<String,String> commitUserData)` Deprecated.
`Document` `document(int n, FieldSelector fieldSelector)` Get the `Document` at the `n` th position.
`protected void` `doDelete(int n)` Deprecated.
`protected IndexReader` `doOpenIfChanged()` If the index has changed since it was opened, open and return a new reader; else, return `null`.
`protected IndexReader` `doOpenIfChanged(boolean openReadOnly)` Deprecated. Write support will be removed in Lucene 4.0. Use `doOpenIfChanged()` instead.
`protected void` `doSetNorm(int n, String field, byte value)` Deprecated.
`protected void` `doUndeleteAll()` Deprecated.
`FieldInfos` `getFieldInfos()` Get the `FieldInfos` describing all fields in this reader.
`IndexReader[]` `getSequentialSubReaders()` Expert: returns the sequential sub readers that this reader is logically composed of.
`TermFreqVector` `getTermFreqVector(int n, String field)` Return a term frequency vector for the specified document and field.
`void` `getTermFreqVector(int docNumber, String field, TermVectorMapper mapper)` Load the Term Vector into a user-defined data structure instead of relying on the parallel arrays of the `TermFreqVector`.
`void` `getTermFreqVector(int docNumber, TermVectorMapper mapper)` Map all the term vectors for all fields in a Document
`TermFreqVector[]` `getTermFreqVectors(int n)` Return an array of term frequency vectors for the specified document.
`long` `getVersion()` Not implemented.
`boolean` `hasDeletions()` Returns true if any documents have been deleted
`boolean` `hasNorms(String field)` Returns true if there are norms stored for this field.
`boolean` `isCurrent()` Checks recursively if all subreaders are up to date.
`boolean` `isDeleted(int n)` Returns true if document n has been deleted
`boolean` `isOptimized()` Deprecated.
`int` `maxDoc()` Returns one greater than the largest possible document number.
`byte[]` `norms(String field)` Returns the byte-encoded normalization factor for the named field of every document.
`void` `norms(String field, byte[] result, int offset)` Reads the byte-encoded normalization factor for the named field of every document.
`int` `numDocs()` Returns the number of documents in this index.
`protected int` `readerIndex(int n)`
`TermDocs` `termDocs()` Returns an unpositioned `TermDocs` enumerator.
`TermDocs` `termDocs(Term term)` Returns an enumeration of all the documents which contain `term`.
`TermPositions` `termPositions()` Returns an unpositioned `TermPositions` enumerator.
`TermEnum` `terms()` Returns an enumeration of all the terms in the index.
`TermEnum` `terms(Term term)` Returns an enumeration of all terms starting at a given term.

Methods inherited from class org.apache.lucene.index.IndexReader

`acquireWriteLock, addReaderClosedListener, close, commit, commit, decRef, deleteDocument, deleteDocuments, directory, document, doOpenIfChanged, doOpenIfChanged, ensureOpen, flush, flush, getCommitUserData, getCommitUserData, getCoreCacheKey, getCurrentVersion, getDeletesCacheKey, getIndexCommit, getRefCount, getTermInfosIndexDivisor, getUniqueTermCount, incRef, indexExists, lastModified, listCommits, numDeletedDocs, open, open, open, open, open, open, open, open, open, open, open, openIfChanged, openIfChanged, openIfChanged, openIfChanged, removeReaderClosedListener, reopen, reopen, reopen, reopen, setNorm, setNorm, termPositions, toString, tryIncRef, undeleteAll`

Methods inherited from class java.lang.Object
`equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### subReaders

    protected final IndexReader[] subReaders

### starts

    protected final int[] starts

Constructor Detail

### MultiReader

    public MultiReader(IndexReader... subReaders)

  Construct a MultiReader aggregating the named set of (sub)readers. Directory locking for delete, undeleteAll, and setNorm operations is left to the subreaders.

  Note that all subreaders are closed if this Multireader is closed.

  Parameters:
    `subReaders` - set of (sub)readers

### MultiReader

    public MultiReader(IndexReader[] subReaders,
                       boolean closeSubReaders)

  Construct a MultiReader aggregating the named set of (sub)readers. Directory locking for delete, undeleteAll, and setNorm operations is left to the subreaders.

  Parameters:
    `closeSubReaders` - indicates whether the subreaders should be closed when this MultiReader is closed
    `subReaders` - set of (sub)readers

Method Detail

### getFieldInfos

    public FieldInfos getFieldInfos()

  Description copied from class: `IndexReader`
  Get the `FieldInfos` describing all fields in this reader. NOTE: do not make any changes to the returned FieldInfos!

  Specified by:
    `getFieldInfos` in class `IndexReader`

### doOpenIfChanged

    protected IndexReader doOpenIfChanged()
                                   throws CorruptIndexException,
                                          IOException

  Description copied from class: `IndexReader`
  If the index has changed since it was opened, open and return a new reader; else, return `null`.

  Overrides:
    `doOpenIfChanged` in class `IndexReader`
  Throws:
    `CorruptIndexException`
    `IOException`
  See Also:
    `IndexReader.openIfChanged(IndexReader)`

### doOpenIfChanged

    @Deprecated
    protected IndexReader doOpenIfChanged(boolean openReadOnly)
                                   throws CorruptIndexException,
                                          IOException

  Deprecated. Write support will be removed in Lucene 4.0. Use `doOpenIfChanged()` instead.

  Description copied from class: `IndexReader`
  If the index has changed since it was opened, open and return a new reader; else, return `null`.

  Overrides:
    `doOpenIfChanged` in class `IndexReader`
  Throws:
    `UnsupportedOperationException` - MultiReaders cannot support changing the readOnly flag
    `CorruptIndexException`
    `IOException`
  See Also:
    `IndexReader.openIfChanged(IndexReader, boolean)`

### clone

    public Object clone()

  Description copied from class: `IndexReader`
  Efficiently clones the IndexReader (sharing most internal state).

  On cloning a reader with pending changes (deletions, norms), the original reader transfers its write lock to the cloned reader. This means only the cloned reader may make further changes to the index, and commit the changes to the index on close, but the old reader still reflects all changes made up until it was cloned.

  Like `IndexReader.openIfChanged(IndexReader)`, it's safe to make changes to either the original or the cloned reader: all shared mutable state obeys "copy on write" semantics to ensure the changes are not seen by other readers.

  Overrides:
    `clone` in class `IndexReader`

### clone

    @Deprecated
    public IndexReader clone(boolean openReadOnly)
                      throws CorruptIndexException,
                             IOException

  Deprecated. Write support will be removed in Lucene 4.0. Use `clone()` instead.

  Description copied from class: `IndexReader`
  Clones the IndexReader and optionally changes readOnly. A readOnly reader cannot open a writeable reader.

  Overrides:
    `clone` in class `IndexReader`
  Throws:
    `UnsupportedOperationException` - MultiReaders cannot support changing the readOnly flag
    `CorruptIndexException` - if the index is corrupt
    `IOException` - if there is a low-level IO error

### getTermFreqVectors

    public TermFreqVector[] getTermFreqVectors(int n)
                                        throws IOException

  Description copied from class: `IndexReader`
  Return an array of term frequency vectors for the specified document. The array contains a vector for each vectorized field in the document. Each vector contains terms and frequencies for all terms in a given vectorized field. If no such fields existed, the method returns null. The term vectors that are returned may either be of type `TermFreqVector` or of type `TermPositionVector` if positions or offsets have been stored.

  Specified by:
    `getTermFreqVectors` in class `IndexReader`
  Parameters:
    `n` - document for which term frequency vectors are returned
  Returns:
    array of term frequency vectors. May be null if no term vectors have been stored for the specified document.
  Throws:
    `IOException` - if index cannot be accessed
  See Also:
    `Field.TermVector`

### getTermFreqVector

    public TermFreqVector getTermFreqVector(int n,
                                            String field)
                                     throws IOException

  Description copied from class: `IndexReader`
  Return a term frequency vector for the specified document and field. The returned vector contains terms and frequencies for the terms in the specified field of this document, if the field had the storeTermVector flag set. If termvectors had been stored with positions or offsets, a `TermPositionVector` is returned.

  Specified by:
    `getTermFreqVector` in class `IndexReader`
  Parameters:
    `n` - document for which the term frequency vector is returned
    `field` - field for which the term frequency vector is returned.
  Returns:
    term frequency vector May be null if field does not exist in the specified document or term vector was not stored.
  Throws:
    `IOException` - if index cannot be accessed
  See Also:
    `Field.TermVector`

### getTermFreqVector

    public void getTermFreqVector(int docNumber,
                                  String field,
                                  TermVectorMapper mapper)
                           throws IOException

  Description copied from class: `IndexReader`
  Load the Term Vector into a user-defined data structure instead of relying on the parallel arrays of the `TermFreqVector`.

  Specified by:
    `getTermFreqVector` in class `IndexReader`
  Parameters:
    `docNumber` - The number of the document to load the vector for
    `field` - The name of the field to load
    `mapper` - The `TermVectorMapper` to process the vector. Must not be null
  Throws:
    `IOException` - if term vectors cannot be accessed or if they do not exist on the field and doc. specified.

### getTermFreqVector

    public void getTermFreqVector(int docNumber,
                                  TermVectorMapper mapper)
                           throws IOException

  Description copied from class: `IndexReader`
  Map all the term vectors for all fields in a Document

  Specified by:
    `getTermFreqVector` in class `IndexReader`
  Parameters:
    `docNumber` - The number of the document to load the vector for
    `mapper` - The `TermVectorMapper` to process the vector. Must not be null
  Throws:
    `IOException` - if term vectors cannot be accessed or if they do not exist on the field and doc. specified.

### isOptimized

    @Deprecated
    public boolean isOptimized()

  Deprecated.

  Overrides:
    `isOptimized` in class `IndexReader`

### numDocs

    public int numDocs()

  Description copied from class: `IndexReader`
  Returns the number of documents in this index.

  Specified by:
    `numDocs` in class `IndexReader`

### maxDoc

    public int maxDoc()

  Description copied from class: `IndexReader`
  Returns one greater than the largest possible document number. This may be used to, e.g., determine how big to allocate an array which will have an element for every document number in an index.

  Specified by:
    `maxDoc` in class `IndexReader`

### document

    public Document document(int n,
                             FieldSelector fieldSelector)
                      throws CorruptIndexException,
                             IOException

  Description copied from class: `IndexReader`
  Get the `Document` at the `n` th position. The `FieldSelector` may be used to determine what `Field`s to load and how they should be loaded. NOTE: If this Reader (more specifically, the underlying `FieldsReader`) is closed before the lazy `Field` is loaded an exception may be thrown. If you want the value of a lazy `Field` to be available after closing you must explicitly load it or fetch the Document again with a new loader.

  NOTE: for performance reasons, this method does not check if the requested document is deleted, and therefore asking for a deleted document may yield unspecified results. Usually this is not required, however you can call `IndexReader.isDeleted(int)` with the requested document ID to verify the document is not deleted.

  Specified by:
    `document` in class `IndexReader`
  Parameters:
    `n` - Get the document at the `n`th position
    `fieldSelector` - The `FieldSelector` to use to determine what Fields should be loaded on the Document. May be null, in which case all Fields will be loaded.
  Returns:
    The stored fields of the `Document` at the nth position
  Throws:
    `CorruptIndexException` - if the index is corrupt
    `IOException` - if there is a low-level IO error
  See Also:
    `Fieldable`, `FieldSelector`, `SetBasedFieldSelector`, `LoadFirstFieldSelector`

### isDeleted

    public boolean isDeleted(int n)

  Description copied from class: `IndexReader`
  Returns true if document n has been deleted

  Specified by:
    `isDeleted` in class `IndexReader`

### hasDeletions

    public boolean hasDeletions()

  Description copied from class: `IndexReader`
  Returns true if any documents have been deleted

  Specified by:
    `hasDeletions` in class `IndexReader`

### doDelete

    @Deprecated
    protected void doDelete(int n)
                     throws CorruptIndexException,
                            IOException

  Deprecated.

  Implements deletion of the document numbered `docNum`. Applications should call `IndexReader.deleteDocument(int)` or `IndexReader.deleteDocuments(Term)`.

  Specified by:
    `doDelete` in class `IndexReader`
  Throws:
    `CorruptIndexException`
    `IOException`

### doUndeleteAll

    @Deprecated
    protected void doUndeleteAll()
                          throws CorruptIndexException,
                                 IOException

  Deprecated.

  Implements actual undeleteAll() in subclass.

  Specified by:
    `doUndeleteAll` in class `IndexReader`
  Throws:
    `CorruptIndexException`
    `IOException`

### readerIndex

    protected int readerIndex(int n)

### hasNorms

    public boolean hasNorms(String field)
                     throws IOException

  Description copied from class: `IndexReader`
  Returns true if there are norms stored for this field.

  Overrides:
    `hasNorms` in class `IndexReader`
  Throws:
    `IOException`

### norms

    public byte[] norms(String field)
                 throws IOException

  Description copied from class: `IndexReader`
  Returns the byte-encoded normalization factor for the named field of every document. This is used by the search code to score documents. Returns null if norms were not indexed for this field.

  Specified by:
    `norms` in class `IndexReader`
  Throws:
    `IOException`
  See Also:
    `AbstractField.setBoost(float)`

### norms

    public void norms(String field,
                      byte[] result,
                      int offset)
               throws IOException

  Description copied from class: `IndexReader`
  Reads the byte-encoded normalization factor for the named field of every document. This is used by the search code to score documents.

  Specified by:
    `norms` in class `IndexReader`
  Throws:
    `IOException`
  See Also:
    `AbstractField.setBoost(float)`

### doSetNorm

    @Deprecated
    protected void doSetNorm(int n,
                                        String field,
                                        byte value)
                      throws CorruptIndexException,
                             IOException

  Deprecated.

  Implements setNorm in subclass.

  Specified by:
    `doSetNorm` in class `IndexReader`
  Throws:
    `CorruptIndexException`
    `IOException`

### terms

    public TermEnum terms()
                   throws IOException

  Description copied from class: `IndexReader`
  Returns an enumeration of all the terms in the index. The enumeration is ordered by Term.compareTo(). Each term is greater than all that precede it in the enumeration. Note that after calling terms(), `TermEnum.next()` must be called on the resulting enumeration before calling other methods such as `TermEnum.term()`.

  Specified by:
    `terms` in class `IndexReader`
  Throws:
    `IOException` - if there is a low-level IO error

### terms

    public TermEnum terms(Term term)
                   throws IOException

  Description copied from class: `IndexReader`
  Returns an enumeration of all terms starting at a given term. If the given term does not exist, the enumeration is positioned at the first term greater than the supplied term. The enumeration is ordered by Term.compareTo(). Each term is greater than all that precede it in the enumeration.

  Specified by:
    `terms` in class `IndexReader`
  Throws:
    `IOException` - if there is a low-level IO error

### docFreq

    public int docFreq(Term t)
                throws IOException

  Description copied from class: `IndexReader`
  Returns the number of documents containing the term `t`.

  Specified by:
    `docFreq` in class `IndexReader`
  Throws:
    `IOException` - if there is a low-level IO error

### termDocs

    public TermDocs termDocs()
                      throws IOException

  Description copied from class: `IndexReader`
  Returns an unpositioned `TermDocs` enumerator.

  Note: the TermDocs returned is unpositioned. Before using it, ensure that you first position it with `TermDocs.seek(Term)` or `TermDocs.seek(TermEnum)`.

  Specified by:
    `termDocs` in class `IndexReader`
  Throws:
    `IOException` - if there is a low-level IO error

### termDocs

    public TermDocs termDocs(Term term)
                      throws IOException

  Description copied from class: `IndexReader`
  Returns an enumeration of all the documents which contain `term`. For each document, the document number, the frequency of the term in that document is also provided, for use in search scoring. If term is null, then all non-deleted docs are returned with freq=1. Thus, this method implements the mapping:

  Term => <docNum, freq>*

  The enumeration is ordered by document number. Each document number is greater than all that precede it in the enumeration.

  Overrides:
    `termDocs` in class `IndexReader`
  Throws:
    `IOException` - if there is a low-level IO error

### termPositions

    public TermPositions termPositions()
                                throws IOException

  Description copied from class: `IndexReader`
  Returns an unpositioned `TermPositions` enumerator.

  Specified by:
    `termPositions` in class `IndexReader`
  Throws:
    `IOException` - if there is a low-level IO error

### doCommit

    @Deprecated
    protected void doCommit(Map<String,String> commitUserData)
                     throws IOException

  Deprecated.

  Implements commit.

  Specified by:
    `doCommit` in class `IndexReader`
  Throws:
    `IOException`

### doClose

    protected void doClose()
                    throws IOException

  Description copied from class: `IndexReader`
  Implements close.

  Specified by:
    `doClose` in class `IndexReader`
  Throws:
    `IOException`

### isCurrent

    public boolean isCurrent()
                      throws CorruptIndexException,
                             IOException

  Checks recursively if all subreaders are up to date.

  Overrides:
    `isCurrent` in class `IndexReader`
  Throws:
    `CorruptIndexException` - if the index is corrupt
    `IOException` - if there is a low-level IO error

### getVersion

    public long getVersion()

  Not implemented.

  Overrides:
    `getVersion` in class `IndexReader`
  Throws:
    `UnsupportedOperationException`

### getSequentialSubReaders

    public IndexReader[] getSequentialSubReaders()

  Description copied from class: `IndexReader`
  Expert: returns the sequential sub readers that this reader is logically composed of. For example, IndexSearcher uses this API to drive searching by one sub reader at a time. If this reader is not composed of sequential child readers, it should return null. If this method returns an empty array, that means this reader is a null reader (for example a MultiReader that has no sub readers).

  NOTE: You should not try using sub-readers returned by this method to make any changes (setNorm, deleteDocument, etc.). While this might succeed for one composite reader (like MultiReader), it will most likely lead to index corruption for other readers (like DirectoryReader obtained through `IndexReader.open(org.apache.lucene.store.Directory)`. Use the parent reader directly.

  Overrides:
    `getSequentialSubReaders` in class `IndexReader`